package
{
	import ca.esdot.lib.display.SpriteSheetClip;
	
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.media.StageWebView;
	import flash.net.dns.AAAARecord;
	import flash.text.TextField;
	import flash.utils.getTimer;
	import flash.utils.setTimeout;
	
	import net.hires.debug.Stats;
	
	public class CachedSpriteSheetTest extends Sprite
	{
		[Embed("assets/moledig.png")]
		public var MoleDigSheet:Class;
		
		[Embed("assets/moledig.json", mimeType="application/octet-stream")]
		public var MoleDigData:Class;
		
		
		protected var spriteContainer:Sprite;
		protected var moles:Vector.<DisplayObject>
		protected var prevTime:int;
		protected var movieClipMode:Boolean = false;
		protected var stats:Stats;
		protected var numChildrenText:TextField;
		
		public function CachedSpriteSheetTest()
		{
			stage.align = StageAlign.TOP_LEFT;
			stage.color = 0x0;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.frameRate = 30;
			stage.quality = StageQuality.LOW;
			
			spriteContainer = new Sprite();
			addChild(spriteContainer);
			
			moles = new Vector.<DisplayObject>();
			
			//Give stage time to size...
			setTimeout(init, 100);
		}
		
		protected function init():void {
			stats = new Stats();
			addChild(stats);
			
			numChildrenText = new TextField();
			numChildrenText.y = 80;
			numChildrenText.text = "0";
			numChildrenText.width = 25;
			numChildrenText.height = 20;
			numChildrenText.scaleX = numChildrenText.scaleY = 2;
			numChildrenText.opaqueBackground = 0xFFFFFF;
			addChild(numChildrenText);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		protected function onEnterFrame(event:Event):void {
			addSprite();
			
			var mole:SpriteSheetClip;
			for(var i:int = 0, l:int = moles.length; i < l; i++){
				mole = moles[i] as SpriteSheetClip;
				translateSprite(mole);
				mole.step();
			}
			
		}
		
		protected function translateSprite(sprite:DisplayObject):void {
			if(sprite.scaleX > 0){
				sprite.x -= 2;
			} else {
				sprite.x += 2;
			}
			if(sprite.x > stage.stageWidth || sprite.x < -sprite.width){
				sprite.x = (stage.stageWidth - sprite.width) * Math.random();
				sprite.y = (stage.stageHeight - sprite.height) * Math.random();
			}
		}
		
		protected function addSprite():void {
			var t:int = getTimer() - prevTime;
			prevTime = getTimer();
			if(stats.currentFps >= 29){
				
				var mole:SpriteSheetClip = new SpriteSheetClip(MoleDigSheet, MoleDigData); 
				mole.scaleX = (Math.random() > .5)? -1 : 1;
				mole.gotoAndPlay("dig", true); 
				
				//Position randomly on stage
				mole.x = (stage.stageWidth - mole.frameWidth) * Math.random();
				mole.y = (stage.stageHeight - mole.frameHeight) * Math.random();
				spriteContainer.addChildAt(mole, 0);
				
				moles.push(mole);
				numChildrenText.text = String(moles.length);
			}
		}
	}
}