package
{
	import flash.utils.getTimer;
	import flash.utils.setTimeout;
	
	import fr.kouma.starling.utils.Stats;
	
	import starling.animation.Juggler;
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.text.TextField;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;

	public class StarlingTestRoot extends Sprite
	{
		[Embed(source="assets/starling/moledig.xml", mimeType="application/octet-stream")]
		protected var AtlasXML:Class;
		
		[Embed(source="assets/starling/moledig.png")]
		protected var AtlasTexture:Class;
		
		protected var stats:Stats;
		protected var numChildrenText:TextField;
		protected var moles:Vector.<MovieClip>
		private var prevTime:int;

		private var texture:Texture;

		private var xml:XML;

		private var atlas:TextureAtlas;
		
		public function StarlingTestRoot() {
			
			stats = new Stats();
			addChild(stats);
			
			moles = new Vector.<MovieClip>();
			
			numChildrenText = new TextField(100, 50, "0");
			numChildrenText.fontSize = 32;
			numChildrenText.color = 0xFFFFFF;
			numChildrenText.y = 100;
			addChild(numChildrenText);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			texture = Texture.fromBitmap(new AtlasTexture());
			xml = XML(new AtlasXML());
			atlas = new TextureAtlas(texture, xml);
		}
		
		private function onEnterFrame(event:Event):void {
			addSprite();
			
			var mole:MovieClip;
			for(var i:int = 0, l:int = moles.length; i < l; i++){
				mole = moles[i];
				translateSprite(mole);
			}
		}
		
		protected function translateSprite(sprite:MovieClip):void {
			sprite.x += ((sprite.scaleX < 0)? -2 : 2);
			if(sprite.x > stage.stageWidth || sprite.x < -sprite.width){
				sprite.x = (stage.stageWidth - sprite.width) * Math.random();
				sprite.y = (stage.stageHeight - sprite.height) * Math.random();
			}
		}
		
		protected function addSprite():void {
			var t:int = getTimer() - prevTime;
			prevTime = getTimer();
			if(stats.currentFps >= 29){
				
				var mole:MovieClip = new MovieClip(atlas.getTextures("moledig_frame"), 30);
				mole.play();
				addChildAt(mole, 0);
				Starling.juggler.add(mole);
				
				mole.scaleX = (Math.random() > .5)? -1 : 1;
				
				//Position randomly on stage
				mole.x = (stage.stageWidth - mole.width) * Math.random();
				mole.y = (stage.stageHeight - mole.height) * Math.random();
				
				moles.push(mole);
				numChildrenText.text = String(moles.length);
			}
		}
	}
}